// ControlView.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MetafileExplorerDoc.h"
#include "ControlView.h"
#include "UpdateControls.h"
#include "SelectionChanged.h"
#include "MoveBy.h"
#include "QueryTree.h"
#include "QueryImage.h"
// CControlView

IMPLEMENT_DYNCREATE(CControlView, CFormView)

CControlView::CControlView()
        : CFormView(CControlView::IDD)
{
 initialized = FALSE;
 PanDelta = CSize(0,0);
}

CControlView::~CControlView()
{
}

void CControlView::DoDataExchange(CDataExchange* pDX)
{
        CFormView::DoDataExchange(pDX);
        DDX_Control(pDX, IDC_UP, c_Up);
        DDX_Control(pDX, IDC_DOWN, c_Down);
        DDX_Control(pDX, IDC_DRAW_ALL, c_DrawAll);
        DDX_Control(pDX, IDC_SINGLE_STEP, c_SingleStep);
        DDX_Control(pDX, IDC_TO_SELECTION, c_ToSelection);
        DDX_Control(pDX, IDC_DRAW_CAPTION, x_Draw);
        DDX_Control(pDX, IDC_UPDRAW, c_UpDraw);
        DDX_Control(pDX, IDC_DOWNDRAW, c_DownDraw);
        DDX_Control(pDX, IDC_DRAWICON, c_DrawIcon);
        DDX_Control(pDX, IDC_SPIN_RECT_LEFT, c_SpinRectLeft);
        DDX_Control(pDX, IDC_SPIN_RECT_RIGHT, c_SpinRectRight);
        DDX_Control(pDX, IDC_SPIN_RECT_TOP, c_SpinRectTop);
        DDX_Control(pDX, IDC_SPIN_RECT_BOTTOM, c_SpinRectBottom);
        DDX_Control(pDX, IDC_RECT_LEFT, c_RectLeft);
        DDX_Control(pDX, IDC_RECT_RIGHT, c_RectRight);
        DDX_Control(pDX, IDC_RECT_TOP, c_RectTop);
        DDX_Control(pDX, IDC_RECT_BOTTOM, c_RectBottom);
        DDX_Control(pDX, IDC_USE_HEADER, c_UseHeader);
        DDX_Control(pDX, IDC_USE_CLIENT, c_UseClient);
        DDX_Control(pDX, IDC_USE_HEADER_ASPECT, c_UseAspectRatio);
        DDX_Control(pDX, IDC_USE_SPECIFIC, c_UseSpecific);
        DDX_Control(pDX, IDC_HEADER_RECT, c_HeaderRect);
        DDX_Control(pDX, IDC_CLIENT_RECT, c_ClientRect);
        DDX_Control(pDX, IDC_SPIN_HEADER_ASPECT_MULTIPLIER, c_SpinHeaderAspectMultiplier);
        DDX_Control(pDX, IDC_HEADER_ASPECT_MULTIPLIER, c_HeaderAspectMultiplier);
        DDX_Control(pDX, IDC_HEADER_ASPECT, c_HeaderAspect);
        DDX_Control(pDX, IDC_HEADER_ASPECT_OUT, c_HeaderAspectOut);
        DDX_Control(pDX, IDC_PAN_HORZ, c_PanHorz);
        DDX_Control(pDX, IDC_PAN_VERT, c_PanVert);
        DDX_Control(pDX, IDC_PAN_CAPTION, x_Pan);
}

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CControlView, CFormView)
    ON_BN_CLICKED(IDC_DRAW_ALL, OnBnClickedDrawAll)
    ON_BN_CLICKED(IDC_SINGLE_STEP, OnBnClickedSingleStep)
    ON_BN_CLICKED(IDC_TO_SELECTION, OnBnClickedToSelection)
    ON_BN_CLICKED(IDC_UP, OnBnClickedUp)
    ON_BN_CLICKED(IDC_DOWN, OnBnClickedDown)
    ON_REGISTERED_MESSAGE(UPD_UPDATECONTROLS, OnUpdateControls)
    ON_REGISTERED_MESSAGE(UPD_SELECTIONCHANGED, OnSelectionChanged)
    ON_BN_CLICKED(IDC_UPDRAW, OnBnClickedUpdraw)
    ON_BN_CLICKED(IDC_DOWNDRAW, OnBnClickedDowndraw)
    ON_EN_CHANGE(IDC_RECT_TOP, OnEnChangeRectTop)
    ON_EN_CHANGE(IDC_RECT_LEFT, OnEnChangeRectLeft)
    ON_EN_CHANGE(IDC_RECT_RIGHT, OnEnChangeRectRight)
    ON_EN_CHANGE(IDC_RECT_BOTTOM, OnEnChangeRectBottom)
    ON_BN_CLICKED(IDC_USE_HEADER, OnBnClickedUseHeader)
    ON_BN_CLICKED(IDC_USE_SPECIFIC, OnBnClickedUseSpecific)
    ON_BN_CLICKED(IDC_USE_HEADER_ASPECT, OnBnClickedUseHeaderAspect)
    ON_REGISTERED_MESSAGE(IMG_SEND_RECT, OnSendRect)
    ON_REGISTERED_MESSAGE(QRY_RECT, OnQueryRect)
    ON_BN_CLICKED(IDC_USE_CLIENT, OnBnClickedUseClient)
    ON_EN_CHANGE(IDC_HEADER_ASPECT_MULTIPLIER, OnEnChangeHeaderAspectMultiplier)
    ON_WM_HSCROLL()
    ON_WM_VSCROLL()
END_MESSAGE_MAP()


// CControlView diagnostics

#ifdef _DEBUG
void CControlView::AssertValid() const
{
        CFormView::AssertValid();
}

void CControlView::Dump(CDumpContext& dc) const
{
        CFormView::Dump(dc);
}
#endif //_DEBUG


// CControlView message handlers

/****************************************************************************
*                      CControlView::OnBnClickedDrawAll
* Result: void
*       
* Effect: 
*       Indicates the entire emf file should be drawn
****************************************************************************/

void CControlView::OnBnClickedDrawAll()
    {
     GetDocument()->DrawAll();
    }

void CControlView::OnBnClickedSingleStep()
    {
     GetDocument()->DrawSingleStep();
    }

void CControlView::OnBnClickedToSelection()
    {
     GetDocument()->DrawToSelection();
    }

void CControlView::OnBnClickedUp()
    {
     GetDocument()->SendViewMessage(UPD_MOVE_UP, UPDF_BY_LINE);
    }

void CControlView::OnBnClickedDown()
    {
     GetDocument()->SendViewMessage(UPD_MOVE_DOWN, UPDF_BY_LINE);
    }

/****************************************************************************
*                       CControlView::OnSelectionChanged
* Inputs:
*       WPARAM: unused
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       If the selection changed, redraw if we are in an incremental mode
****************************************************************************/

LRESULT CControlView::OnSelectionChanged(WPARAM, LPARAM)
    {
     if(c_DrawAll.GetCheck() == BST_CHECKED)
        return 0;
     GetDocument()->Invalidate();
     updateControls();     
     return 0;
    } // CControlView::OnSelectionChanged

/****************************************************************************
*                           CControlView::OnUpdate
* Inputs:
*       CView * pSender: ignored
*       LPARAM lHint: What to do
*       CObject * pHint: What to do it with
* Result: void
*       
* Effect: 
*       Handles the update request
****************************************************************************/

void CControlView::OnUpdate(CView* pSender, LPARAM lHint, CObject * pHint)
    {
     if(lHint == 0 && pHint == NULL)
        { /* just redraw */
         CFormView::OnUpdate(pSender, lHint, pHint);
         return;
        } /* just redraw */
     SendMessage((UINT)lHint, (WPARAM)pHint);
    }

/****************************************************************************
*                        CControlView::updateControls
* Result: void
*       
* Effect: 
*       Enables/disables/shows/hides controls
****************************************************************************/

void CControlView::updateControls()
    {
     if(!initialized)
        return;
     
     QueryEnableInfo info;
     GetDocument()->SendViewMessage(QRY_ENABLE, &info);

     BOOL stepping = c_SingleStep.GetCheck() == BST_CHECKED || c_ToSelection.GetCheck() == BST_CHECKED;

     c_Up.EnableWindow(stepping && info.SelectionUp && !info.SelectionEmpty);
     c_Down.EnableWindow(stepping && info.SelectionDown && !info.SelectionEmpty);
     c_UpDraw.EnableWindow(stepping && info.SelectionUpDraw && !info.SelectionEmpty);
     c_DownDraw.EnableWindow(stepping && info.SelectionDownDraw && !info.SelectionEmpty);

     c_DrawAll.EnableWindow(!info.SelectionEmpty);
     c_SingleStep.EnableWindow(!info.SelectionEmpty);
     c_ToSelection.EnableWindow(!info.SelectionEmpty);
     x_Draw.EnableWindow(!info.SelectionEmpty);

     //
     // If UseHeader:
     //         All rect controls are disabled
     // If UseHeaderAspectRatio
     //         
     // If UseSpecific
     //         All are enabled

     BOOL enableUS = c_UseSpecific.GetCheck() == BST_CHECKED;

     c_SpinRectTop.EnableWindow(enableUS);
     c_RectTop.EnableWindow(enableUS);

     c_SpinRectLeft.EnableWindow(enableUS);
     c_RectLeft.EnableWindow(enableUS);

     c_SpinRectRight.EnableWindow(enableUS);
     c_RectRight.EnableWindow(enableUS);

     c_SpinRectBottom.EnableWindow(enableUS);
     c_RectBottom.EnableWindow(enableUS);
    
     x_Pan.EnableWindow(enableUS);
     c_PanHorz.EnableWindow(enableUS);
     c_PanVert.EnableWindow(enableUS);

     BOOL enableAR = c_UseAspectRatio.GetCheck() == BST_CHECKED;
     c_SpinHeaderAspectMultiplier.EnableWindow(enableAR);
     c_HeaderAspectMultiplier.EnableWindow(enableAR);

     CRect r;
     r.SetRectEmpty();
     GetDocument()->SendViewMessage(QRY_RECT, &r, this);
     CString s;
     s.Format(_T("%d, %d, %d, %d"), r.left, r.top, r.right, r.bottom);
     c_HeaderRect.SetWindowText(s);
     
     s.Format(_T("%d, %d"), r.Width(), r.Height());
     c_HeaderAspect.SetWindowText(s);

     int mul = c_SpinHeaderAspectMultiplier.GetPos32();
     s.Format(_T("%d, %d"), r.Width() * mul, r.Height() * mul);
     c_HeaderAspectOut.SetWindowText(s);

     r.SetRectEmpty();
     GetDocument()->SendViewMessage(IMG_QUERY_RECT, &r);
     s.Format(_T("%d, %d, %d, %d"), r.left, r.top, r.right, r.bottom);
     c_ClientRect.SetWindowText(s);
    } // CControlView::updateControls

/****************************************************************************
*                        CControlView::OnInitialUpdate
* Result: void
*       
* Effect: 
*       Handles initialization
****************************************************************************/

void CControlView::OnInitialUpdate()
    {
     CFormView::OnInitialUpdate();

     c_Up.LoadBitmaps(IDB_UP, 0, IDB_UP_DISABLED);
     c_Down.LoadBitmaps(IDB_DOWN, 0, IDB_DOWN_DISABLED);
     c_UpDraw.LoadBitmaps(IDB_UP, 0, IDB_UP_DISABLED);
     c_DownDraw.LoadBitmaps(IDB_DOWN, 0, IDB_DOWN_DISABLED);

     HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_NEXTDRAW), IMAGE_BITMAP, 0, 0,
                               LR_SHARED | LR_LOADMAP3DCOLORS);
     c_DrawIcon.SetBitmap(bmp);

     CheckRadioButton(IDC_DRAW_ALL, IDC_TO_SELECTION, IDC_DRAW_ALL);
     CheckRadioButton(IDC_USE_HEADER, IDC_USE_SPECIFIC, IDC_USE_HEADER);

     c_SpinHeaderAspectMultiplier.SetRange32(1, 2048);
     c_SpinHeaderAspectMultiplier.SetPos32(1);

static const int SCROLL_LIMIT = 1024;
     c_PanHorz.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT);
     c_PanHorz.SetPos32(0);
     c_PanVert.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT);
     c_PanVert.SetPos32(0);
     c_SpinRectLeft.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT);
     c_SpinRectTop.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT);
     c_SpinRectRight.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT);  // can be reset when resized
     c_SpinRectBottom.SetRange32(-SCROLL_LIMIT, SCROLL_LIMIT); // can be reset when resized
     initialized = TRUE;
     updateControls();
    }

/****************************************************************************
*                       CControlView::OnUpdateControls
* Inputs:
*       WPARAM: unused
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Updates the controls
****************************************************************************/

LRESULT CControlView::OnUpdateControls(WPARAM, LPARAM)
    {
     updateControls();
     return 0;
    } // CControlView::OnUpdateControls

/****************************************************************************
*                       CControlView::OnBnClickedUpdraw
* Result: void
*       
* Effect: 
*       Move up to previous drawing
****************************************************************************/
#pragma warning(disable: 4312)
void CControlView::OnBnClickedUpdraw()
    {
     GetDocument()->SendViewMessage(UPD_MOVE_UP, (LPVOID)UPDF_BY_DRAW);
    }

/****************************************************************************
*                      CControlView::OnBnClickedDowndraw
* Result: void
*       
* Effect: 
*       Move down to next drawing
****************************************************************************/

void CControlView::OnBnClickedDowndraw()
    {
     GetDocument()->SendViewMessage(UPD_MOVE_DOWN, (LPVOID)UPDF_BY_DRAW);
    }

/****************************************************************************
*                       CControlView::OnEnChangeRectTop
* Result: void
*       
* Effect: 
*       Handles change in the rectangle top
****************************************************************************/

void CControlView::OnEnChangeRectTop()
    {
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                       CControlView::OnEnChangeRectLeft
* Result: void
*       
* Effect: 
*       Handles change in rect left position
****************************************************************************/

void CControlView::OnEnChangeRectLeft()
    {
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                      CControlView::OnEnChangeRectRight
* Result: void
*       
* Effect: 
*       Handles change in rect right
****************************************************************************/

void CControlView::OnEnChangeRectRight()
    {
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                      CControlView::OnEnChangeRectBottom
* Result: void
*       
* Effect: 
*       Handles change in rect bottom
****************************************************************************/

void CControlView::OnEnChangeRectBottom()
    {
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                CControlView::OnEnChangeHeaderAspectMultiplier
* Result: void
*       
* Effect: 
*       Handles change in aspect multiplier
****************************************************************************/

void CControlView::OnEnChangeHeaderAspectMultiplier()
    {
     updateControls();
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                      CControlView::OnBnClickedUseHeader
* Result: void
*       
* Effect: 
*       Handles selection to header rectangle
****************************************************************************/

void CControlView::OnBnClickedUseHeader()
    {
     updateControls();
     GetDocument()->Invalidate();
    }

/****************************************************************************
*                      CControlView::OnBnClickedUseClient
* Result: void
*       
* Effect: 
*       Handles selection to client rectangle
****************************************************************************/

void CControlView::OnBnClickedUseClient()
   {
    updateControls();
    GetDocument()->Invalidate();
   }


/****************************************************************************
*                     CControlView::OnBnClickedUseSpecific
* Result: void
*       
* Effect: 
*       Handles selection of specific rectangle
****************************************************************************/

void CControlView::OnBnClickedUseSpecific()
    {
     updateControls();
     GetDocument()->Invalidate();
    }


/****************************************************************************
*                   CControlView::OnBnClickedUseHeaderAspect
* Result: void
*       
* Effect: 
*       Handles selection of header aspect ratio
****************************************************************************/

void CControlView::OnBnClickedUseHeaderAspect()
    {
     updateControls();
     GetDocument()->Invalidate();
    }

/****************************************************************************
*                          CControlView::OnSendRect
* Inputs:
*       WPARAM: (WPARAM)(CRect *) Image rectangle
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Updates the image rectangle display
****************************************************************************/

LRESULT CControlView::OnSendRect(WPARAM wParam, LPARAM)
    {
     if(c_SpinRectRight.GetSafeHwnd() == NULL)
         return 0;
     if(c_SpinRectBottom.GetSafeHwnd() == NULL)
         return 0;
     if(c_ClientRect.GetSafeHwnd() == NULL)
         return 0;

     CRect * r = (CRect *)wParam;

     CString s;
     s.Format(_T("%d, %d, %d, %d"), r->left, r->top, r->right, r->bottom);
     c_ClientRect.SetWindowText(s);
     c_SpinRectRight.SetRange32(0, r->right);
     c_SpinRectBottom.SetRange32(0, r->bottom);
     return 0;
    } // CControlView::OnSendRect

/****************************************************************************
*                          CControlView::OnQueryRect
* Inputs:
*       WPARAM: (WPARAM)(CRect*) Rectangle to be filled in
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Fills in the rectangle if appropriate
****************************************************************************/

LRESULT CControlView::OnQueryRect(WPARAM wParam, LPARAM)
    {
     CRect * r = (CRect *)wParam;

     if(c_UseHeader.GetCheck() == BST_CHECKED)
        return 0;   // let someone else do it

     if(c_UseClient.GetCheck() == BST_CHECKED)
        { /* use client */
         GetDocument()->SendViewMessage(IMG_QUERY_RECT, (LPVOID)r);
         return 0;
        } /* use client */

     if(c_UseAspectRatio.GetCheck() == BST_CHECKED)
        { /* use aspect ratio */
         CRect img;
         img.SetRectEmpty();
         GetDocument()->SendViewMessage(QRY_RECT, &img, this);
         int mul = c_SpinHeaderAspectMultiplier.GetPos32();
         r->left = img.left;
         r->top = img.top;
         r->right = img.right * mul;
         r->bottom = img.bottom * mul;
         return 0;
        } /* use aspect ratio */

     if(c_UseSpecific.GetCheck() == BST_CHECKED)
        { /* specific */
         CRect specific(c_SpinRectLeft.GetPos32(),
                        c_SpinRectTop.GetPos32(),
                        c_SpinRectRight.GetPos32(),
                        c_SpinRectBottom.GetPos32());
         *r = specific;
         return 0;
        } /* specific */
     return 0;
    } // CControlView::OnQueryRect

/****************************************************************************
*                           CControlView::OnHScroll
* Inputs:
*       UINT nSBCode: Scrollbar code
*       UINT nPos: Position
*       CScrollBar * pScrollBar
* Result: void
*       
* Effect: 
*       Handles HSCROLL events
****************************************************************************/

void CControlView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar * pScrollBar)
    {
     if(pScrollBar == (CScrollBar *)&c_PanHorz)
        PanHorizontal(nPos);
     else
        CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
    } // CControlView::OnHScroll

/****************************************************************************
*                           CControlView::OnVScroll
* Inputs:
*       UINT nSBCode: Scrollbar code
*       UINT nPos: Position
*       CScrollBar * pScrollBar
* Result: void
*       
* Effect: 
*       Handles VSCROLL events 
****************************************************************************/

void CControlView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar * pScrollBar)
   {
    if(pScrollBar == (CScrollBar *)&c_PanVert)
       PanVertical(nPos);
    else
       CFormView::OnVScroll(nSBCode, nPos, pScrollBar);
   } // CControlView::OnVScroll

/****************************************************************************
*                         CControlView::PanHorizontal
* Inputs:
*       UINT nPos: Position value
* Result: void
*       
* Effect: 
*       Amount to pan 
****************************************************************************/

void CControlView::PanHorizontal(UINT nPos)
    {
     int dx = (int)nPos - PanDelta.cx;
     int x = c_SpinRectLeft.GetPos32();
     x += dx;
     c_SpinRectLeft.SetPos32(x);
     x = c_SpinRectRight.GetPos32();
     x += dx;
     c_SpinRectRight.SetPos32(x);
     PanDelta.cx += dx;
    } // CControlView::PanHorizontal

/****************************************************************************
*                          CControlView::PanVertical
* Inputs:
*       UINT nPos: Position from scroller
* Result: void
*       
* Effect: 
*       Scrolls vertically
****************************************************************************/

void CControlView::PanVertical(UINT nPos)
    {
     int dy = (int)nPos - PanDelta.cy;
     int y = c_SpinRectTop.GetPos32();
     y += dy;
     c_SpinRectTop.SetPos32(y);
     y = c_SpinRectBottom.GetPos32();
     y += dy;
     c_SpinRectBottom.SetPos32(y);
     PanDelta.cy += dy;
    } // CControlView::PanVertical
