#pragma once

#include "ImageButton.h"

class CMetafileExplorerDoc;

// CControlView form view

class CControlView : public CFormView
{
        DECLARE_DYNCREATE(CControlView)

protected:
        CControlView();           // protected constructor used by dynamic creation
        virtual ~CControlView();

public:
        enum { IDD = IDD_CONTROL };
#ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
#endif

protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

        DECLARE_MESSAGE_MAP()
protected:
    inline CMetafileExplorerDoc * GetDocument() { return (CMetafileExplorerDoc*)m_pDocument; }
    void updateControls();
    void OnSelectionChanged();

    void PanHorizontal(UINT pos);
    void PanVertical(UINT pos);
    CSize PanDelta;
    BOOL initialized;
protected:
    afx_msg LRESULT OnSelectionChanged(WPARAM, LPARAM);
    afx_msg LRESULT OnUpdateControls(WPARAM, LPARAM);

    afx_msg void OnBnClickedDrawAll();
    afx_msg void OnBnClickedSingleStep();
    afx_msg void OnBnClickedToSelection();
    afx_msg void OnBnClickedUp();
    afx_msg void OnBnClickedDown();
    afx_msg void OnBnClickedUpdraw();
    afx_msg void OnBnClickedDowndraw();
    afx_msg void OnEnChangeRectTop();
    afx_msg void OnEnChangeRectLeft();
    afx_msg void OnEnChangeRectRight();
    afx_msg void OnEnChangeRectBottom();
    afx_msg void OnBnClickedUseHeader();
    afx_msg void OnBnClickedUseClient();
    afx_msg void OnBnClickedUseSpecific();
    afx_msg void OnBnClickedUseHeaderAspect();
    afx_msg void OnEnChangeHeaderAspectMultiplier();
    afx_msg LRESULT OnSendRect(WPARAM, LPARAM);
    afx_msg LRESULT OnQueryRect(WPARAM, LPARAM);
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar * pScrollBar);
    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar * pScrollBar);
protected:
    virtual void OnInitialUpdate();
    virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
protected:
   CImageButton c_Up;
   CImageButton c_Down;
   CImageButton c_UpDraw;
   CImageButton c_DownDraw;
   CButton c_DrawAll;
   CButton c_SingleStep;
   CButton c_ToSelection;
   CStatic x_Draw;
   CStatic c_DrawIcon;
   CSpinButtonCtrl c_SpinRectLeft;
   CSpinButtonCtrl c_SpinRectTop;
   CSpinButtonCtrl c_SpinRectBottom;
   CSpinButtonCtrl c_SpinRectRight;
   CEdit c_RectLeft;
   CEdit c_RectTop;
   CEdit c_RectBottom;
   CEdit c_RectRight;
   CButton c_UseHeader;
   CButton c_UseClient;
   CButton c_UseAspectRatio;
   CButton c_UseSpecific;
   CStatic c_HeaderRect;
   CStatic c_ClientRect;
   CSpinButtonCtrl c_SpinHeaderAspectMultiplier;
   CEdit c_HeaderAspectMultiplier;
   CStatic c_HeaderAspect;
   CStatic c_HeaderAspectOut;
   CSpinButtonCtrl c_PanHorz;
   CSpinButtonCtrl c_PanVert;
   CButton x_Pan;
};


