#pragma once

#define DECODE_PARAMETERS const ENHMETARECORD * rec, LPVOID p1, LPVOID p2

class EMFDecode {
    public:
       void Decode(const ENHMETARECORD * rec, LPVOID p1, LPVOID p2);
    protected:
       virtual void DecodeAbortPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeAlphaBlend(DECODE_PARAMETERS) PURE;
       virtual void DecodeAngleArc(DECODE_PARAMETERS) PURE;
       virtual void DecodeArc(DECODE_PARAMETERS) PURE;
       virtual void DecodeArcTo(DECODE_PARAMETERS) PURE;
       virtual void DecodeBeginPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeBitBlt(DECODE_PARAMETERS) PURE;
       virtual void DecodeChord(DECODE_PARAMETERS) PURE;
       virtual void DecodeCloseFigure(DECODE_PARAMETERS) PURE;
       virtual void DecodeColorCorrectPalette(DECODE_PARAMETERS) PURE;
       virtual void DecodeColorMatchToTargetW(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreateBrushIndirect(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreateColorSpace(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreateColorSpaceW(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreateDIBPatternBrushPt(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreateMonoBrush(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreatePalette(DECODE_PARAMETERS) PURE;
       virtual void DecodeCreatePen(DECODE_PARAMETERS) PURE;
       virtual void DecodeDeleteColorSpace(DECODE_PARAMETERS) PURE;
       virtual void DecodeDeleteObject(DECODE_PARAMETERS) PURE;
       virtual void DecodeEllipse(DECODE_PARAMETERS) PURE;
       virtual void DecodeEndPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeEOF(DECODE_PARAMETERS) PURE;
       virtual void DecodeExcludeClipRect(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtCreateFontIndirectW(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtCreatePen(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtFloodFill(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtSelectClipRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtTextOutA(DECODE_PARAMETERS) PURE;
       virtual void DecodeExtTextOutW(DECODE_PARAMETERS) PURE;
       virtual void DecodeFillPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeFillRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodeFlattenPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeFrameRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodeGdiComment(DECODE_PARAMETERS) PURE;
       virtual void DecodeGLSBoundedRecord(DECODE_PARAMETERS) PURE;
       virtual void DecodeGLSRecord(DECODE_PARAMETERS) PURE;
       virtual void DecodeGradientFill(DECODE_PARAMETERS) PURE;
       virtual void DecodeHeader(DECODE_PARAMETERS) PURE;
       virtual void DecodeIntersectClipRect(DECODE_PARAMETERS) PURE;
       virtual void DecodeInvertRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodeLineTo(DECODE_PARAMETERS) PURE;
       virtual void DecodeMaskBlt(DECODE_PARAMETERS) PURE;
       virtual void DecodeModifyWorldTransform(DECODE_PARAMETERS) PURE;
       virtual void DecodeMoveToEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeOffsetClipRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodePaintRgn(DECODE_PARAMETERS) PURE;
       virtual void DecodePie(DECODE_PARAMETERS) PURE;
       virtual void DecodePixelFormat(DECODE_PARAMETERS) PURE;
       virtual void DecodePlgBlt(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyBezier(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyBezier16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyBezierTo(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyBezierTo16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyDraw(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyDraw16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolygon(DECODE_PARAMETERS) PURE;
       virtual void DecodePolygon16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyLine(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyLine16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyLineTo(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyLineTo16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyPolygon(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyPolygon16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyPolyLine(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyPolyLine16(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyTextOutA(DECODE_PARAMETERS) PURE;
       virtual void DecodePolyTextOutW(DECODE_PARAMETERS) PURE;
       virtual void DecodeRealizePalette(DECODE_PARAMETERS) PURE;
       virtual void DecodeRectangle(DECODE_PARAMETERS) PURE;
       virtual void DecodeResizePalette(DECODE_PARAMETERS) PURE;
       virtual void DecodeRestoreDC(DECODE_PARAMETERS) PURE;
       virtual void DecodeRoundRect(DECODE_PARAMETERS) PURE;
       virtual void DecodeSaveDC(DECODE_PARAMETERS) PURE;
       virtual void DecodeScaleViewportExtEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeScaleWindowExtEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSelectClipPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeSelectColorSpace(DECODE_PARAMETERS) PURE;
       virtual void DecodeSelectObject(DECODE_PARAMETERS) PURE;
       virtual void DecodeSelectPalette(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetArcDirection(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetBkColor(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetBkMode(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetBrushOrgEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetColorAdjustment(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetColorSpace(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetDIBitsToDevice(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetICMMode(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetICMProfileA(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetICMProfileW(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetLayout(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetMapMode(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetMapperFlags(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetMetaRegion(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetMiterLimit(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetPaletteEntries(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetPixelV(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetPolyFillMode(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetROP2(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetStretchBltMode(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetTextAlign(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetTextColor(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetViewportExtEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetViewportOrgEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetWindowExtEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetWindowOrgEx(DECODE_PARAMETERS) PURE;
       virtual void DecodeSetWorldTransform(DECODE_PARAMETERS) PURE;
       virtual void DecodeStretchBlt(DECODE_PARAMETERS) PURE;
       virtual void DecodeStretchDIBits(DECODE_PARAMETERS) PURE;
       virtual void DecodeStrokeAndFillPath(DECODE_PARAMETERS) PURE;
       virtual void DecodeStrokePath(DECODE_PARAMETERS) PURE;
       virtual void DecodeTransparentBlt(DECODE_PARAMETERS) PURE;
       virtual void DecodeWidenPath(DECODE_PARAMETERS) PURE;
};
