// MetafileExplorerDoc.h : interface of the CMetafileExplorerDoc class
//


#pragma once

class CMetafileExplorerDoc : public CDocument
{
protected: // create from serialization only
        CMetafileExplorerDoc();
        DECLARE_DYNCREATE(CMetafileExplorerDoc)

// Attributes
public:

// Operations
public:

// Overrides
public:
   virtual BOOL OnOpenDocument(LPCTSTR filename);
   virtual BOOL OnNewDocument();
   virtual void Serialize(CArchive& ar);
   virtual void OnCloseDocument();

// Implementation
public:
        virtual ~CMetafileExplorerDoc();
#if 0
        //*********************************************************************************************
        // Inter-view messages
        //
        typedef enum {
        //****************************************************************
                                UpdateFileName,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: UpdateFileName
        //    CObject * pHint: (CObject*)(LPCTSTR) File name for tree
        //
        // Source: Document
        // Target: Tree view
        //
        // Effect:
        //    The file name for the root
        // Notes:
        //    This message is sent only once, before any UpdateRawRecord messages
        //****************************************************************
                                UpdateRawRecord,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: UpdateRawRecord
        //    CObject * pHint: (CObject*)(EMR *) Metarecord to be added to list
        //
        // Source: Document
        // Target: Tree view
        //
        // Effect:
        //    Adds the MetaRecord to the tree
        //****************************************************************
                                    MoveUp,
                                   MoveDown,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: Move__
        //    CObject* pHint: NULL
        //
        // Source: Any view that can move the selection up or down
        // Target: Tree view
        //
        // Effect:
        //    Moves the selection up or down
        // Notes:
        //    This moves the selection based on the record-level options,
        //    so if the selection is on a tree below a record-level, the
        //    selection is moved to the next record-level item
        //****************************************************************
                                   EnableUp,
                                  EnableDown,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint:  Enable__
        //    CObject * pHint:  (CObject*)(BOOL) state of the button
        //
        // Source: Any view that can move the selection up or down
        // Target: Control view
        //
        // Effect:
        //    Enables/disables the appropriate button
        //****************************************************************
                               QueryShowRequest,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: QueryShowRequest
        //    CObject * pHint:  (CObject *)(QueryInfo*)
        //
        // Source: Any drawing view
        // Target: Tree view
        //
        // Effect:
        //    Queries the tree to see if the metarecord should be displayed
        //****************************************************************
                                  QueryEnable,
        //****************************************************************
        // Inputs:
        //   LPARAM lHint: QueryEnable
        //   CObject * pHint: (CObject*)(QueryEnableInfo*)
        //
        // Source: Any view with controls
        // Target: Tree view
        //
        // Effect:
        //   Queries the tree to see if the selection is movable
        //****************************************************************
                                  RedrawImage,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: RedrawImage
        //    CObject * pHint: NULL
        //
        // Source: Any view, or the document
        // Target: Image view
        //
        // Effect:
        //    Invalidates the image so it will be redrawn
        //****************************************************************
                                UpdateControls,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: UpdateControls
        //    CObject * pHint: NULL
        //
        // Source: Any view, or the document
        // Target: Control view (or any view with controls)
        //
        // Effect:
        //    Requests the control view update its controls
        //****************************************************************
                                   QueryRect,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: UpdateControls
        //    CObject * pHint: (CObject*)(CRect *)
        //
        // Source: Drawing view
        // Target: Tree View
        //
        // Effect:
        //    Asks the metafile how large its drawing area is
        //****************************************************************
                              SelectionChanged,
        //****************************************************************
        // Inputs:
        //    LPARAM lHint: SelectionChanged
        //    CObject * pHint: NULL
        //
        // Source: Tree view
        // Target: All other views
        //
        // Effect:
        //    Indicates the selection has changed
        //****************************************************************
        } UpdateType;
#endif
public:
        //*****************************************************************************
        // Inter-view methods
        //*****************************************************************************
        void DrawAll();                 // Request the drawing mode be "All"
        void DrawSingleStep();          // Request the drawing mode be "Single step"
        void DrawToSelection();         // Request the drawing mode be "Draw to selection"
        void updateControls();          // Request any views with controls update their controls
        void Invalidate();              // Invalidates any drawing

        void SendViewMessage(UINT msg, LPVOID p = NULL, CView * view = NULL);
        BOOL QueryShow(CONST ENHMETARECORD * record); // Ask if this record should be shown

public: // data retrieval
        HENHMETAFILE GetMetaFile() { return meta; }

public: // Debugging methods
#ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   typedef enum { DoDrawSingleStep, DoDrawToSelection, DoDrawAll, DoDrawNone } DrawMode;

   void ProcessMetafile(LPCTSTR filename);
   DrawMode mode;
   HENHMETAFILE meta;
   static int CALLBACK metaEnum(HDC, HANDLETABLE *, CONST ENHMETARECORD *, int, LPARAM);
// Generated message map functions
protected:
        DECLARE_MESSAGE_MAP()
};


