#pragma once
#include "msg.h"

/****************************************************************************
*                                  QRY_RECT
* Inputs:
*       WPARAM: (WPARAM)(CRect *): Rectangle
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       A view that has a a bounding rectangle for the metafile fills it the
*       rectangle
****************************************************************************/

DECLARE_MESSAGE(QRY_RECT)

/****************************************************************************
*                               QRY_SHOWREQUEST
* Inputs:
*       WPARAM: (WPARAM)
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Asks that the ShowRequest structure be filled in
****************************************************************************/

DECLARE_MESSAGE(QRY_SHOWREQUEST)

/****************************************************************************
*                             class QueryShowInfo
****************************************************************************/

class QueryShowInfo {
    public:
       QueryShowInfo(CONST ENHMETARECORD * r) {record = r; show = FALSE; }
    public:
       CONST ENHMETARECORD * record;
       BOOL show;
};

/****************************************************************************
*                                 QRY_ENABLE
* Inputs:
*       WPARAM: (WPARAM)(QueryEnable *)
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Queries views to see if controls should be enabled
****************************************************************************/

DECLARE_MESSAGE(QRY_ENABLE)

/****************************************************************************
*                            class QueryEnableInfo
****************************************************************************/

class QueryEnableInfo {
    public:
       QueryEnableInfo() { SelectionUp = SelectionDown = SelectionUpDraw = SelectionDownDraw = FALSE;  SelectionEmpty = TRUE; }
    public:
       BOOL SelectionUp;         // Selection can move up
       BOOL SelectionDown;       // Selection can move down
       BOOL SelectionUpDraw;     // Selection can move up to previous draw
       BOOL SelectionDownDraw;   // Selection can move down to next draw
       BOOL SelectionEmpty;      // Nothing to do
};


/****************************************************************************
*                                  QRY_NAME
* Inputs:
*       WPARAM: (WPARAM)(CStringW *) Place to fill in name
*       LPARAM: Unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Obtains the name from the ENHMETAHEADER
****************************************************************************/

DECLARE_MESSAGE(QRY_NAME)

/****************************************************************************
*                                 QRY_HEADER
* Inputs:
*       WPARAM: (WPARAM)(ENHMETAHEADER **) WPARAM: Place to put metaheader pointer
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Gets a pointer to the 
****************************************************************************/

DECLARE_MESSAGE(QRY_HEADER)
