#pragma once

#include "EMFDecode.h"
#include "StateIcon.h"

class TreeDecode : public EMFDecode {
    protected:
       virtual void DecodeAbortPath(DECODE_PARAMETERS);
       virtual void DecodeAlphaBlend(DECODE_PARAMETERS);
       virtual void DecodeAngleArc(DECODE_PARAMETERS);
       virtual void DecodeArc(DECODE_PARAMETERS);
       virtual void DecodeArcTo(DECODE_PARAMETERS);
       virtual void DecodeBeginPath(DECODE_PARAMETERS);
       virtual void DecodeBitBlt(DECODE_PARAMETERS);
       virtual void DecodeChord(DECODE_PARAMETERS);
       virtual void DecodeCloseFigure(DECODE_PARAMETERS);
       virtual void DecodeColorCorrectPalette(DECODE_PARAMETERS);
       virtual void DecodeColorMatchToTargetW(DECODE_PARAMETERS);
       virtual void DecodeCreateBrushIndirect(DECODE_PARAMETERS);
       virtual void DecodeCreateColorSpace(DECODE_PARAMETERS);
       virtual void DecodeCreateColorSpaceW(DECODE_PARAMETERS);
       virtual void DecodeCreateDIBPatternBrushPt(DECODE_PARAMETERS);
       virtual void DecodeCreateMonoBrush(DECODE_PARAMETERS);
       virtual void DecodeCreatePalette(DECODE_PARAMETERS);
       virtual void DecodeCreatePen(DECODE_PARAMETERS);
       virtual void DecodeDeleteColorSpace(DECODE_PARAMETERS);
       virtual void DecodeDeleteObject(DECODE_PARAMETERS);
       virtual void DecodeEllipse(DECODE_PARAMETERS);
       virtual void DecodeEndPath(DECODE_PARAMETERS);
       virtual void DecodeEOF(DECODE_PARAMETERS);
       virtual void DecodeExcludeClipRect(DECODE_PARAMETERS);
       virtual void DecodeExtCreateFontIndirectW(DECODE_PARAMETERS);
       virtual void DecodeExtCreatePen(DECODE_PARAMETERS);
       virtual void DecodeExtFloodFill(DECODE_PARAMETERS);
       virtual void DecodeExtSelectClipRgn(DECODE_PARAMETERS);
       virtual void DecodeExtTextOutA(DECODE_PARAMETERS);
       virtual void DecodeExtTextOutW(DECODE_PARAMETERS);
       virtual void DecodeFillPath(DECODE_PARAMETERS);
       virtual void DecodeFillRgn(DECODE_PARAMETERS);
       virtual void DecodeFlattenPath(DECODE_PARAMETERS);
       virtual void DecodeFrameRgn(DECODE_PARAMETERS);
       virtual void DecodeGdiComment(DECODE_PARAMETERS);
       virtual void DecodeGLSBoundedRecord(DECODE_PARAMETERS);
       virtual void DecodeGLSRecord(DECODE_PARAMETERS);
       virtual void DecodeGradientFill(DECODE_PARAMETERS);
       virtual void DecodeHeader(DECODE_PARAMETERS);
       virtual void DecodeIntersectClipRect(DECODE_PARAMETERS);
       virtual void DecodeInvertRgn(DECODE_PARAMETERS);
       virtual void DecodeLineTo(DECODE_PARAMETERS);
       virtual void DecodeMaskBlt(DECODE_PARAMETERS);
       virtual void DecodeModifyWorldTransform(DECODE_PARAMETERS);
       virtual void DecodeMoveToEx(DECODE_PARAMETERS);
       virtual void DecodeOffsetClipRgn(DECODE_PARAMETERS);
       virtual void DecodePaintRgn(DECODE_PARAMETERS);
       virtual void DecodePie(DECODE_PARAMETERS);
       virtual void DecodePixelFormat(DECODE_PARAMETERS);
       virtual void DecodePlgBlt(DECODE_PARAMETERS);
       virtual void DecodePolyBezier(DECODE_PARAMETERS);
       virtual void DecodePolyBezier16(DECODE_PARAMETERS);
       virtual void DecodePolyBezierTo(DECODE_PARAMETERS);
       virtual void DecodePolyBezierTo16(DECODE_PARAMETERS);
       virtual void DecodePolyDraw(DECODE_PARAMETERS);
       virtual void DecodePolyDraw16(DECODE_PARAMETERS);
       virtual void DecodePolygon(DECODE_PARAMETERS);
       virtual void DecodePolygon16(DECODE_PARAMETERS);
       virtual void DecodePolyLine(DECODE_PARAMETERS);
       virtual void DecodePolyLine16(DECODE_PARAMETERS);
       virtual void DecodePolyLineTo(DECODE_PARAMETERS);
       virtual void DecodePolyLineTo16(DECODE_PARAMETERS);
       virtual void DecodePolyPolygon(DECODE_PARAMETERS);
       virtual void DecodePolyPolygon16(DECODE_PARAMETERS);
       virtual void DecodePolyPolyLine(DECODE_PARAMETERS);
       virtual void DecodePolyPolyLine16(DECODE_PARAMETERS);
       virtual void DecodePolyTextOutA(DECODE_PARAMETERS);
       virtual void DecodePolyTextOutW(DECODE_PARAMETERS);
       virtual void DecodeRealizePalette(DECODE_PARAMETERS);
       virtual void DecodeRectangle(DECODE_PARAMETERS);
       virtual void DecodeResizePalette(DECODE_PARAMETERS);
       virtual void DecodeRestoreDC(DECODE_PARAMETERS);
       virtual void DecodeRoundRect(DECODE_PARAMETERS);
       virtual void DecodeSaveDC(DECODE_PARAMETERS);
       virtual void DecodeScaleViewportExtEx(DECODE_PARAMETERS);
       virtual void DecodeScaleWindowExtEx(DECODE_PARAMETERS);
       virtual void DecodeSelectClipPath(DECODE_PARAMETERS);
       virtual void DecodeSelectColorSpace(DECODE_PARAMETERS);
       virtual void DecodeSelectObject(DECODE_PARAMETERS);
       virtual void DecodeSelectPalette(DECODE_PARAMETERS);
       virtual void DecodeSetArcDirection(DECODE_PARAMETERS);
       virtual void DecodeSetBkColor(DECODE_PARAMETERS);
       virtual void DecodeSetBkMode(DECODE_PARAMETERS);
       virtual void DecodeSetBrushOrgEx(DECODE_PARAMETERS);
       virtual void DecodeSetColorAdjustment(DECODE_PARAMETERS);
       virtual void DecodeSetColorSpace(DECODE_PARAMETERS);
       virtual void DecodeSetDIBitsToDevice(DECODE_PARAMETERS);
       virtual void DecodeSetICMMode(DECODE_PARAMETERS);
       virtual void DecodeSetICMProfileA(DECODE_PARAMETERS);
       virtual void DecodeSetICMProfileW(DECODE_PARAMETERS);
       virtual void DecodeSetLayout(DECODE_PARAMETERS);
       virtual void DecodeSetMapMode(DECODE_PARAMETERS);
       virtual void DecodeSetMapperFlags(DECODE_PARAMETERS);
       virtual void DecodeSetMetaRegion(DECODE_PARAMETERS);
       virtual void DecodeSetMiterLimit(DECODE_PARAMETERS);
       virtual void DecodeSetPaletteEntries(DECODE_PARAMETERS);
       virtual void DecodeSetPixelV(DECODE_PARAMETERS);
       virtual void DecodeSetPolyFillMode(DECODE_PARAMETERS);
       virtual void DecodeSetROP2(DECODE_PARAMETERS);
       virtual void DecodeSetStretchBltMode(DECODE_PARAMETERS);
       virtual void DecodeSetTextAlign(DECODE_PARAMETERS);
       virtual void DecodeSetTextColor(DECODE_PARAMETERS);
       virtual void DecodeSetViewportExtEx(DECODE_PARAMETERS);
       virtual void DecodeSetViewportOrgEx(DECODE_PARAMETERS);
       virtual void DecodeSetWindowExtEx(DECODE_PARAMETERS);
       virtual void DecodeSetWindowOrgEx(DECODE_PARAMETERS);
       virtual void DecodeSetWorldTransform(DECODE_PARAMETERS);
       virtual void DecodeStretchBlt(DECODE_PARAMETERS);
       virtual void DecodeStretchDIBits(DECODE_PARAMETERS);
       virtual void DecodeStrokeAndFillPath(DECODE_PARAMETERS);
       virtual void DecodeStrokePath(DECODE_PARAMETERS);
       virtual void DecodeTransparentBlt(DECODE_PARAMETERS);
       virtual void DecodeWidenPath(DECODE_PARAMETERS);
    protected:
       static CString cvtAC(DWORD mode);
       static CString cvtAD(DWORD mode);
       static CString cvtBIC(DWORD mode);
       static CString cvtBKM(UINT iMode);
       static CString cvtBS(UINT brush);
       static CString cvtC16(COLOR16 c);
       static CString cvtCAF(WORD flags);
       static CString cvtCCSF(DWORD flags);
       static CString cvtCST(LCSCSTYPE type);
       static CString cvtCGPS(DWORD ps);
       static CString cvtCMTT(DWORD flags);
       static CString cvtCR(COLORREF clr);
       static CString cvtDBC(DWORD c);
       static CString cvtDT(BYTE dt);
       static CString cvtEC(DWORD ps);
       static CString cvtEJ(DWORD ps);
       static CString cvtEPS(DWORD ps);
       static CString cvtFF(DWORD iMode);
       static CString cvtFW(LONG fw);
       static CString cvtFXPT230(FXPT2DOT30 value);
       static CString cvtGF(ULONG ulMode);
       static CString cvtGM(DWORD iGraphicsMode);
       static CString cvtHT(UINT style);
       static CString cvtIC(DWORD mode);
       static CString cvtII(WORD ii);
       static CString cvtIN(LCSGAMUTMATCH mode);
       static CString cvtLBS(UINT style);
       static CString cvtLY(DWORD iMode);
       static CString cvtMM(DWORD iMode);
       static CString cvtMWT(DWORD iMode);
       static CString cvtOB(DWORD handle);
       static CString cvtPANAS(BYTE b);
       static CString cvtPANCO(BYTE b);
       static CString cvtPANFT(BYTE b);
       static CString cvtPANLF(BYTE b);
       static CString cvtPANML(BYTE b);
       static CString cvtPANPR(BYTE b);
       static CString cvtPANSS(BYTE b);
       static CString cvtPANSV(BYTE b);
       static CString cvtPANWT(BYTE b);
       static CString cvtPANXH(BYTE b);
       static CString cvtPEF(BYTE flags);
       static CString cvtPFF(DWORD dwFlags);
       static CString cvtPFM(DWORD iMode);
       static CString cvtPS(UINT ps);
       static CString cvtPT(BYTE pt);
       static CString cvtRCmm(RECTL r);
       static CString cvtRDHT(DWORD iType);
       static CString cvtRGN(DWORD iMode);
       static CString cvtROP(DWORD rop);
       static CString cvtROP2(DWORD rop);
       static CString cvtSBM(DWORD iMode);
       static CString cvtSig(DWORD sig);
       static CString cvtSO(DWORD so);
       static CString cvtString(LPCWSTR s);
       static CString cvtString(LPCSTR s);
       static CString cvtTA(DWORD iMode);
       static CString cvtTA1(DWORD iMode);
       static CString cvtTA2(DWORD iMode);
       static CString cvtTA3(DWORD iMode);
       static CString cvtTA4(DWORD iMode);
       static CString cvtTextOptions(DWORD options);

       static CString cvt(BYTE b);
       static CString cvt(DWORD v);
       static CString cvt(LONG v);      
       static CString cvt(FLOAT f);
       static CString cvt(POINT pt);
       static CString cvt(POINTL pt);
       static CString cvt(RECT r);
       static CString cvt(RECTL r);
       static CString cvt(SHORT v);
       static CString cvt(SIZEL pt);
       static CString cvt(UINT v);
       static CString cvt(WORD v);
       static CString cvt(XFORM X);
       
       static void AddVal(CString & target, CString & sep, const CString & val);
       static void SetState(CTreeCtrl * ctl, HTREEITEM item, StateIcon::States state);

       static void FormatBITMAPINFO(const BITMAPINFO * bmi, LPVOID p1, LPVOID p2);
       static void FormatBITMAPINFOHEADER(const BITMAPINFOHEADER * bmi, LPVOID p1, LPVOID p2);
       static void FormatCIEXYZ(const CIEXYZ * cie, LPVOID p1, LPVOID p2);
       static void FormatCIEXYZTRIPLE(const CIEXYZTRIPLE * triple, LPVOID p1, LPVOID p2);
       static void FormatCOLORADJUSTMENT(const COLORADJUSTMENT * ca, LPVOID p1, LPVOID p2);
       static void FormatDrawTypes(LPBYTE data, LPVOID p1, LPVOID p2, DWORD count);
       static void FormatDWORDs(const DWORD * data, LPVOID p1, LPVOID p2, DWORD count);
       static void FormatEMRText1(const EMRTEXT * text, LPVOID p1, LPVOID p2);
       static void FormatEMRText2(const DWORD * sp, DWORD offset, DWORD len, LPVOID p1, LPVOID p2);
       static void FormatEMRTextA(const EMRTEXT * text, LPVOID p1, LPVOID p2, LPCVOID p3);
       static void FormatEMRTextAa(const EMRTEXT * text, LPVOID p1, LPVOID p2, LPCVOID p3, LONG count);
       static void FormatEMRTextW(const EMRTEXT * text, LPVOID p1, LPVOID p2, LPCVOID p3);
       static void FormatEMRTextWa(const EMRTEXT * text, LPVOID p1, LPVOID p2, LPCVOID p3, LONG count);
       static void FormatEXTLOGFONTW(const EXTLOGFONTW * lf, LPVOID p1, LPVOID p2);
       static void FormatEXTLOGPEN(const EXTLOGPEN * lp, LPVOID p1, LPVOID p2);
       static void FormatGdiCommentData(const LPBYTE data, LPVOID p1, LPVOID p2, DWORD len);
       static void FormatGRADIENT_RECT(const GRADIENT_RECT * gr, LPVOID p1, LPVOID p2);
       static void FormatGRADIENT_RECTs(const GRADIENT_RECT * gr, LPVOID p1, LPVOID p2, DWORD len);
       static void FormatGRADIENT_TRIANGLE(const GRADIENT_TRIANGLE * gr, LPVOID p1, LPVOID p2);
       static void FormatGRADIENT_TRIANGLEs(const GRADIENT_TRIANGLE * gr, LPVOID p1, LPVOID p2, DWORD len);
       static void FormatLOGBRUSH32(const LOGBRUSH32 * lb, LPVOID p1, LPVOID p2);
       static void FormatLOGCOLORSPACE(const LOGCOLORSPACEA * lcs, LPVOID p1, LPVOID p2);
       static void FormatLOGCOLORSPACEA(const LOGCOLORSPACEA * lcs, LPVOID p1, LPVOID p2);
       static void FormatLOGCOLORSPACEW(const LOGCOLORSPACEW * lcs, LPVOID p1, LPVOID p2);
       static void FormatLOGFONTW(const LOGFONTW * lf, LPVOID p1, LPVOID p2);
       static void FormatLOGPALETTE(const LOGPALETTE * pal, LPVOID p1, LPVOID p2);
       static void FormatLOGPEN(const LOGPEN * lp, LPVOID p1, LPVOID p2);
       static void FormatPALETTEENTRIES(const PALETTEENTRY * pal, DWORD count, LPVOID p1, LPVOID p2);
       static void FormatPALETTEENTRY(const PALETTEENTRY * pal, LPVOID p1, LPVOID p2);
       static void FormatPANOSE(const PANOSE * panose, LPVOID p1, LPVOID p2);
       static void FormatPIXELFORMATDESCRIPTOR(const PIXELFORMATDESCRIPTOR * pfd, LPVOID p1, LPVOID p2);
       static void FormatPOINTL(const POINTL * pts, LPVOID p1, LPVOID p2, DWORD count);
       static void FormatPOINTS(const POINTS * pts, LPVOID p1, LPVOID p2, DWORD count);
       static void FormatRECTArray(const LPRECT array, LPVOID p1, LPVOID p2, DWORD count);
       static void FormatRGNDATA(const RGNDATA * rgn, LPVOID p1, LPVOID p2);
       static void FormatRGNDATAHEADER(const RGNDATAHEADER * rgn, LPVOID p1, LPVOID p2);
       static void FormatTRIVERTEX(const TRIVERTEX *, LPVOID p1, LPVOID p2);
       static void FormatTRIVERTEXes(const TRIVERTEX *, LPVOID p1, LPVOID p2, DWORD count);

    protected:
       static DWORD GetWinVer();
       HTREEITEM GetLastItem(CTreeCtrl * ctl, HTREEITEM item = TVI_ROOT);
};
